<?php

class LoginController extends Publicapi
{

	private $objLogin;

	/**
	 * 初始化
	 *
	 * @return void
	 *
	 */
	public function init()
	{
		parent::init();
		
		error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
		$this->objLogin = new LoginModel();
		$this->objLogin->initTmp();
	}

	/**
	 * 文件路径
	 *
	 * @return void
	 *
	 */
	public function filerouteAction()
	{
		$fn = empty($_GET['__fn']) ? '' : $_GET['__fn'];
		
		switch ($fn) {
			case 'login':
				$this->login();
				exit();
			case 'logout':
				$this->logout();
				exit();
			case 'activation':
				$this->activation();
				exit();
			default:
		}
		
		$this->to();
	}

	/**
	 * 首页
	 *
	 * @return void
	 *
	 */
	public function indexAction()
	{
		error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
		$objPassport = new PassportModel();
		
		$arr = $this->memcacheActivationCode();
		
		// mac地址
		$mac = new GetMacAddr(PHP_OS);
		
		$arr = array(
			'obj' => $this,
			'mac_addr' => $mac->mac_addr,
			'login_theme_css' => $this->_data['login_theme_css'],
			'arr' => $arr
		);
		
		$this->display('login', $arr);
	}

	/**
	 * 登录
	 */
	public function login()
	{
		$username = _POST('username');
		$password = _POST('password');
		//$password = sha1($password);
		
		// 检查激活
		$bool = $this->checkActivationCode();
		if ($bool !== true) {
			$this->ajaxReturnData($bool, false);
			return false;
		}
		
		// 检查尝试次数
		$login_attempt_limit = isset($this->_data['settings_info']['login_attempt_limit']) ? $this->_data['settings_info']['login_attempt_limit'] : '7';
		$login_locking = isset($this->_data['settings_info']['login_locking']) ? $this->_data['settings_info']['login_locking'] : '1800';
		if ($this->_session->login_attempt_limit >= $login_attempt_limit && $this->_session->login_locking >= time()) {
			$this->ajaxReturnData('登录锁定，请' . ceil($login_locking / 60) . '分钟后再试', false);
			return false;
		}
		
		// 检查锁定时间
		if ($this->_session->login_locking < time()) {
			unset($this->_session->login_attempt_limit);
			unset($this->_session->login_locking);
		}
		
		// 获取用户信息
		$member_info = $this->objLogin->getUsers($username, $password);
		
		if (! empty($member_info)) {
			$this->_session->uid = $member_info[0]['ID'];
			$this->_session->username = $member_info[0]['username'];
			$this->_session->usertype = $member_info[0]['usertype'];
			$this->_session->timeStamp = time();
			
			// 设置用户管理的我的分组
			$this->objLogin->getMyGroupInfo($member_info);
			// 设置用户管理的系统分组
			$this->objLogin->getSysGroupInfo($member_info);
			// 设置用户管理设备
			$this->objLogin->getEquipmentsInof($member_info);
			// 获取我的分组主机IP地址
			$this->objLogin->getMyGroupHostIp();
			// 设置数据库表
			$this->memcacheDatabaseTable();
			// 设置参数设置
			$this->memcacheParameters();
			// 设置微信access_token
			$this->memcacheAccessToken();
			// 设置设备-参数设置
			$this->memcacheDeviceParameter();
			// 门禁设置
			$this->memcacheEguard();
			// 超链接
			$this->memcacheHyperlink();
			// 设置memcache分组信息
			$this->memcacheUpdateMapGroup();
			// 设置memcache所有分组
			$this->memcacheGroups();
			// 设置memcache漏水画线
			$this->memcacheDrawing();
			// 设置memcache所有用户
			$this->memcacheUsers();
			// 设置memcache所有资产登记
			$this->memcacheAssetRegistration();
			// 设置memcache所有有平均值的机房
			$this->memcacheAvgGroups();
			// 设置memcache告警数标志
			$this->memcacheAlertNumberSign();
			// 设置memcache所有声光报警器
			$this->memcacheAudibleVisualAlarm();
			// 设置memcache所有ping设备
			$this->memcachePing();
			// 设置memcache人脸识别设备
			$this->memcacheFaceRecognition();
			
			// 保存机房设备类型列表
			$this->memcacheGroupEquipmentTypeList();
			
			// 验证签名
			$this->_session->openssl = $this->getOpenssl();
			
			// 记录操作日志
			$this->sendLog('1');
			
			// 清除错误次数
			unset($this->_session->login_attempt_limit);
			unset($this->_session->login_locking);
			
			$this->ajaxReturnData(0, true, array(
				'url' => '/',
				'uid' => $this->_session->uid
			));
		} else {
			// 记录错误次数
			$this->_session->login_attempt_limit = isset($this->_session->login_attempt_limit) ? $this->_session->login_attempt_limit + 1 : 1;
			$this->_session->login_locking = time() + $login_locking;
			$strMsg = $login_attempt_limit - $this->_session->login_attempt_limit <= 0 ? ('登录锁定，请' . ceil($login_locking / 60) . '分钟后再试') : '用户名或密码错误，' . ($login_attempt_limit - $this->_session->login_attempt_limit) . '次后锁定';
			
			$this->ajaxReturnData($strMsg, false);
		}
	}

	/**
	 * 退出
	 */
	public function logout()
	{
		// 记录操作日志
		$this->sendLog('2');
		
		unset($this->_session->uid);
		unset($this->_session->username);
		unset($this->_session->usertype);
		
		$this->to('/login/login/index/');
	}

	/**
	 * 激活
	 */
	public function activation()
	{
		$serial_number = _POST('serial_number');
		$activation_code = _POST('activation_code');
		$strMsg = '';
		
		$arrInfo = array(
			'serial_number' => $serial_number,
			'activation_code' => $activation_code
		);
		$arrResult = $this->objLogin->setActivationCode($arrInfo);
		
		if (! empty($arrResult)) {
			$this->ajaxReturnData("激活成功", true, $arrResult);
		} else {
			$this->ajaxReturnData("无效激活码", false);
		}
	}
}